/*
 * Created on September 20, 2006
 *
 */
package com.vividsolutions.jump.workbench.ui.plugin.cormat;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;

import javax.swing.*;

import com.vividsolutions.jump.util.Blackboard;
import com.vividsolutions.jump.workbench.plugin.*;
import com.vividsolutions.jump.workbench.ui.GUIUtil;
import com.vividsolutions.jump.workbench.ui.images.IconLoader;
import com.vividsolutions.jump.workbench.ui.plugin.PersistentBlackboardPlugIn;

import javax.swing.filechooser.FileFilter;


/** 
 * This class executes the Cormat Plug-In 
 * 
 */

public class CormatPlugIn extends AbstractPlugIn {

	private static int JTEXTFIELD_LENGTH = 50;
	
	private static String cormatInFileName = "";
	private static String cormatCormatFileName= "";
	private static String cormatOutFileName = "";

    private static File cormatInFile;
    private static File cormatCormatFile;
    private static File cormatOutFile;

    private static boolean addOutFileToLayer = true;
    
	static boolean executeCormatflag = false;

	public String getName() {
		return "Apply CorMat Correction Matrices";
	}

	public CormatPlugIn() {
        super("Cormat");
    }
    
    public void initialize(PlugInContext context) throws Exception {
    	context.getFeatureInstaller().addLayerViewMenuItem(this,				  
    			new String[] { "CORMAT" },getName());
    }

    public boolean execute(PlugInContext context) throws Exception {
    	
        JDialog dlg = new CormatDialog(context);

        dlg.pack();
        dlg.setResizable(false);
        dlg.setModal(true);
        GUIUtil.centre(dlg, context.getWorkbenchFrame());
        dlg.setVisible(true);

        /* Check the execute CORMAT flag */
        if (executeCormatflag == true){
    		CormatExecuter executer = new CormatExecuter();
    	    executer.execute(context, addOutFileToLayer, cormatInFile, cormatCormatFile, cormatOutFile);
    		// Set execute CORMAT flag to false
    	    executeCormatflag = false;
        }; /*if*/
        
        return false;
    }

    private static class CormatDialog extends JDialog {
    	
		/**
		 * 
		 */
		private static final long serialVersionUID = -434237584026550070L;
		private PlugInContext context;
        private JLabel infilelabel;
        private JLabel cormatfilelabel;
        private JLabel outfilelabel;
        private JTextField infiletext;
        private JTextField cormatfiletext;
        private JTextField outfiletext;
        
        public CormatDialog(PlugInContext context) {
          super(context.getWorkbenchFrame());
            this.context = context;
            setTitle("CorMat PlugIn Manager v1.01");

            initialize();
            
        }

        private void initialize() {
        	
            JPanel infilePanel = createInFilePanel();
            JPanel cormatfilePanel = createCormatFilePanel();
            JPanel outfilePanel = createOutFilePanel();
            JPanel buttonPanel = createButtonPanel();
            JPanel dialogPanel = new JPanel(new GridLayout(4,2));

            dialogPanel.add(infilePanel);
            dialogPanel.add(cormatfilePanel);
            dialogPanel.add(outfilePanel);
            dialogPanel.add(buttonPanel);

            getContentPane().add(dialogPanel);
            
        }


        private JPanel createInFilePanel() {
        	
            JPanel infilePanel = new JPanel();

            infilelabel = new JLabel();
            infilelabel.setText("In File");
            infilelabel.setFont(context.getActiveInternalFrame().getFont());
            infilelabel.setBackground(getBackground());
            infilePanel.add(infilelabel);

            if (cormatInFile != null){cormatInFileName = cormatInFile.getPath();};
            infiletext = new JTextField(cormatInFileName, JTEXTFIELD_LENGTH);
            infiletext.setBackground(Color.white);
            infiletext.setAutoscrolls(false);
            infiletext.setFont(context.getActiveInternalFrame().getFont());
            infiletext.setBorder(BorderFactory.createEtchedBorder());
            infiletext.setEditable(false);
            infilePanel.add(infiletext);
            
            JButton infilebutton = new JButton("Select InFile", GUIUtil.toSmallIcon(IconLoader.icon("Folder.gif")));
            infilebutton.addActionListener(new InButtonListener());
            infilePanel.add(infilebutton);
            
            return infilePanel;
            
        }

        private JPanel createCormatFilePanel() {

            JPanel cormatfilePanel = new JPanel();

            cormatfilelabel = new JLabel();
            cormatfilelabel.setText("Cormat File");
            cormatfilelabel.setFont(context.getActiveInternalFrame().getFont());
            cormatfilelabel.setBackground(getBackground());
            cormatfilePanel.add(cormatfilelabel);

            if (cormatCormatFile != null){cormatCormatFileName = cormatCormatFile.getPath();};
            cormatfiletext = new JTextField(cormatCormatFileName, JTEXTFIELD_LENGTH);
            cormatfiletext.setAutoscrolls(false);
            cormatfiletext.setBackground(Color.white);
            cormatfiletext.setFont(context.getActiveInternalFrame().getFont());
            cormatfiletext.setBorder(BorderFactory.createEtchedBorder());
            cormatfiletext.setEditable(false);
            cormatfilePanel.add(cormatfiletext);
            
            JButton cormatfilebutton = new JButton("Select CormatFile", GUIUtil.toSmallIcon(IconLoader.icon("Folder.gif")));
            cormatfilebutton.addActionListener(new CormatButtonListener());
            cormatfilePanel.add(cormatfilebutton);
            
            return cormatfilePanel;
        	
        }

        private JPanel createOutFilePanel() {

            JPanel outfilePanel = new JPanel();

            outfilelabel = new JLabel();
            outfilelabel.setText("Out File");
            outfilelabel.setFont(context.getActiveInternalFrame().getFont());
            outfilelabel.setBackground(getBackground());
            outfilePanel.add(outfilelabel);

            if (cormatOutFile != null){cormatOutFileName = cormatOutFile.getPath();};
            outfiletext = new JTextField(cormatOutFileName, JTEXTFIELD_LENGTH);
            outfiletext.setAutoscrolls(false);
            outfiletext.setBackground(Color.white);
            outfiletext.setFont(context.getActiveInternalFrame().getFont());
            outfiletext.setBorder(BorderFactory.createEtchedBorder());
            outfiletext.setEditable(false);
            outfilePanel.add(outfiletext);
            
            JButton outfilebutton = new JButton("Select OutFile", GUIUtil.toSmallIcon(IconLoader.icon("Folder.gif")));
            outfilebutton.addActionListener(new OutButtonListener());
            outfilePanel.add(outfilebutton);
            
            return outfilePanel;
        	
        }

        private JPanel createButtonPanel() {
        	
            JPanel buttonPanel = new JPanel();

            JButton executebutton = new JButton("Execute", GUIUtil.toSmallIcon(IconLoader.icon("Plus.gif")));
//            JButton executebutton = new JButton("Execute", GUIUtil.toSmallIcon(IconLoader.icon("CormatExecute.jpg")));
            executebutton.addActionListener(new ExecuteButtonListener(this));
            buttonPanel.add(executebutton);

            JButton cancelbutton = new JButton("Cancel", GUIUtil.toSmallIcon(IconLoader.icon("Delete.gif")));
//            JButton cancelbutton = new JButton("Cancel", GUIUtil.toSmallIcon(IconLoader.icon("CormatCancel.jpg")));
            cancelbutton.addActionListener(new CancelButtonListener(this));
            buttonPanel.add( cancelbutton );

            return buttonPanel;
            
        }

        private void selectInFileName(){

            final String LAST_DIRECTORY_KEY = getClass().getName()+ " - LAST DIRECTORY";

            JFrame frame = new JFrame();
            Blackboard blackboard = PersistentBlackboardPlugIn.get(context.getWorkbenchContext() );
            JFileChooser chooser = GUIUtil.createJFileChooserWithExistenceChecking();
            chooser.setCurrentDirectory( new File(
                    ( String ) blackboard.get( LAST_DIRECTORY_KEY, chooser.getCurrentDirectory().getPath() ) ) );
            GUIUtil.removeChoosableFileFilters(chooser);
            String ShpList[] = new String[1];
            ShpList[0] = GUIUtil.shp; 
            FileFilter fileFilter = GUIUtil.createFileFilter(GUIUtil.shpDesc, ShpList);
            chooser.addChoosableFileFilter( fileFilter );
            chooser.setFileFilter( fileFilter );
            
            // Show dialog; this method does not return until dialog is closed
         	chooser.setSelectedFile(cormatInFile);
          	int option = chooser.showOpenDialog(frame);
        
          	// Check if Approved
          	if (option == JFileChooser.APPROVE_OPTION)
          	{
          		// Get the selected In file
          		cormatInFile = chooser.getSelectedFile();
          		if (cormatInFile != null){cormatInFileName = cormatInFile.getPath();};
          		infiletext.setText(cormatInFileName);
          	}; /*if*/

        }

        private void selectCormatFileName(){

            final String LAST_DIRECTORY_KEY = getClass().getName()+ " - LAST DIRECTORY";

            JFrame frame = new JFrame();
            Blackboard blackboard = PersistentBlackboardPlugIn.get(context.getWorkbenchContext() );
            JFileChooser chooser = GUIUtil.createJFileChooserWithExistenceChecking();
            chooser.setCurrentDirectory( new File(
                    ( String ) blackboard.get( LAST_DIRECTORY_KEY, chooser.getCurrentDirectory().getPath() ) ) );
            GUIUtil.removeChoosableFileFilters(chooser);
            String CmtList[] = new String[1];
            CmtList[0] = "txt"; 
            FileFilter fileFilter = GUIUtil.createFileFilter("Cormat Data File", CmtList);
            chooser.addChoosableFileFilter( fileFilter );
            chooser.setFileFilter( fileFilter );
       
            // Show dialog; this method does not return until dialog is closed
         	chooser.setSelectedFile(cormatCormatFile);
          	int option = chooser.showOpenDialog(frame);
        
          	// Check if Approved
          	if (option == JFileChooser.APPROVE_OPTION)
          	{
          		// Get the selected Cormat file
          		cormatCormatFile = chooser.getSelectedFile();
          		if (cormatCormatFile != null){cormatCormatFileName = cormatCormatFile.getPath();};
          		cormatfiletext.setText(cormatCormatFileName);
          	}; /*if*/

        }

        private void selectOutFileName(){

            final String LAST_DIRECTORY_KEY = getClass().getName()+ " - LAST DIRECTORY";

            JFrame frame = new JFrame();
            Blackboard blackboard = PersistentBlackboardPlugIn.get(context.getWorkbenchContext() );
            JFileChooser chooser = GUIUtil.createJFileChooserWithOverwritePrompting();
            chooser.setCurrentDirectory( new File(
                    ( String ) blackboard.get( LAST_DIRECTORY_KEY, chooser.getCurrentDirectory().getPath() ) ) );
            GUIUtil.removeChoosableFileFilters(chooser);
            String ShpList[] = new String[1];
            ShpList[0] = GUIUtil.shp; 
            FileFilter fileFilter = GUIUtil.createFileFilter(GUIUtil.shpDesc, ShpList);
            chooser.addChoosableFileFilter( fileFilter );
            chooser.setFileFilter( fileFilter );
        
            // Show dialog; this method does not return until dialog is closed
         	chooser.setSelectedFile(cormatOutFile);
          	int option = chooser.showOpenDialog(frame);
        
          	// Check if Approved
          	if (option == JFileChooser.APPROVE_OPTION)
          	{
          		// Get the selected Out file
          		cormatOutFile = chooser.getSelectedFile();
          		if (cormatOutFile != null){cormatOutFileName = cormatOutFile.getPath();};
          		outfiletext.setText(cormatOutFileName);
          	}; /*if*/

        }
        
        private class InButtonListener implements ActionListener {
            public void actionPerformed(ActionEvent e) {
                selectInFileName();
            }
        }
        
        private class CormatButtonListener implements ActionListener {
            public void actionPerformed(ActionEvent e) {
                selectCormatFileName();
            }
        }

        private class OutButtonListener implements ActionListener {
            public void actionPerformed(ActionEvent e) {
                selectOutFileName();
            }
        }

        private class ExecuteButtonListener implements ActionListener {
        	private JDialog dialog;        	
        	
            ExecuteButtonListener(JDialog dlg) {
                dialog = dlg;
            }
            
            public void actionPerformed(ActionEvent e) {

        		// Set execute CORMAT flag to true
        	    executeCormatflag = true;

        	    // Close the CORMAT Dialog Box
                dialog.dispose();

            }
        }

        private class CancelButtonListener implements ActionListener {
            private JDialog dialog;

            CancelButtonListener(JDialog dlg) {
                dialog = dlg;
            }

            public void actionPerformed(ActionEvent e) {
            	
        		// Set execute CORMAT flag to false
        	    executeCormatflag = false;
            	
        	    // Close the CORMAT Dialog Box
                dialog.dispose();
                
            }
        }
    }
}
